package com.sa.ibiz.demo.demo.rest;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.sa.ibiz.demo.demo.domain.DataSyncAgent;
import com.sa.ibiz.demo.demo.service.DataSyncAgentService;
import com.sa.ibiz.demo.demo.service.dto.DataSyncAgentSearchFilter;
import com.sa.ibiz.demo.ibizutil.errors.BadRequestAlertException;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;
import java.math.BigInteger;
import java.util.List;

@RestController
@RequestMapping("/demo/datasyncagent")
public class DataSyncAgentResource
{
	@Autowired
	private DataSyncAgentService service;


	@PostMapping(value = "/checkKey")
	public ResponseEntity<DataSyncAgent> checkKey(@Validated @RequestBody DataSyncAgent data){
		boolean bRt=service.checkKey(data);
		if(!bRt)
			throw new BadRequestAlertException("数据同步代理[checkKey]操作发生错误","DataSyncAgent",data.getDatasyncagentid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/getDraft")
	public ResponseEntity<DataSyncAgent> getDraft(@Validated @RequestBody DataSyncAgent data){
		boolean bRt=service.getDraft(data);
		if(!bRt)
			throw new BadRequestAlertException("数据同步代理[getDraft]操作发生错误","DataSyncAgent","");
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/remove")
	public ResponseEntity<DataSyncAgent> remove(@Validated @RequestBody DataSyncAgent data){
		boolean bRt=service.remove(data);
		if(!bRt)
			throw new BadRequestAlertException("数据同步代理[remove]操作发生错误","DataSyncAgent",data.getDatasyncagentid().toString());
		return ResponseEntity.ok().body(data);
	}
	@GetMapping(value = "/{id}")
	public ResponseEntity<DataSyncAgent> get(@Validated @PathVariable String id){
		DataSyncAgent data=new DataSyncAgent();
		data.setDatasyncagentid(id);;
		data=service.get(data);
		if(data==null)
			throw new BadRequestAlertException("数据同步代理[get]操作发生错误","DataSyncAgent",id.toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/create")
	public ResponseEntity<DataSyncAgent> create(@Validated @RequestBody DataSyncAgent data){
		boolean bRt=service.create(data);
		if(!bRt)
			throw new BadRequestAlertException("数据同步代理[create]操作发生错误","DataSyncAgent",data.getDatasyncagentid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/update")
	public ResponseEntity<DataSyncAgent> update(@Validated @RequestBody DataSyncAgent data){
		boolean bRt=service.update(data);
		if(!bRt)
			throw new BadRequestAlertException("数据同步代理[update]操作发生错误","DataSyncAgent",data.getDatasyncagentid().toString());
		return ResponseEntity.ok().body(data);
	}
    @PostMapping(value="/searchdefault")
	public ResponseEntity<Page<DataSyncAgent>> searchDefaultPage(@Validated @RequestBody DataSyncAgentSearchFilter filter){
		Page<DataSyncAgent> searchResult = service.searchDefault(filter);
		return ResponseEntity.ok().body(searchResult);
	}

	@PostMapping(value="/listdefault")
	public ResponseEntity<List<DataSyncAgent>> listDefault(@Validated @RequestBody DataSyncAgentSearchFilter filter){
		List<DataSyncAgent> searchResult = service.listDefault(filter);
		return ResponseEntity.ok().body(searchResult);
	}
}
